

# CreateModel
<a name="API_CreateModel"></a>

Adds a new Model resource to an existing RestApi resource.

## Request Syntax
<a name="API_CreateModel_RequestSyntax"></a>

```
POST /restapis/restapi_id/models HTTP/1.1
Content-type: application/json

{
   "contentType": "string",
   "description": "string",
   "name": "string",
   "schema": "string"
}
```

## URI Request Parameters
<a name="API_CreateModel_RequestParameters"></a>

The request uses the following URI parameters.

 ** [restapi\$1id](#API_CreateModel_RequestSyntax) **   <a name="apigw-CreateModel-request-uri-restApiId"></a>
The RestApi identifier under which the Model will be created.  
Required: Yes

## Request Body
<a name="API_CreateModel_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [contentType](#API_CreateModel_RequestSyntax) **   <a name="apigw-CreateModel-request-contentType"></a>
The content-type for the model.  
Type: String  
Required: Yes

 ** [description](#API_CreateModel_RequestSyntax) **   <a name="apigw-CreateModel-request-description"></a>
The description of the model.  
Type: String  
Required: No

 ** [name](#API_CreateModel_RequestSyntax) **   <a name="apigw-CreateModel-request-name"></a>
The name of the model. Must be alphanumeric.  
Type: String  
Required: Yes

 ** [schema](#API_CreateModel_RequestSyntax) **   <a name="apigw-CreateModel-request-schema"></a>
The schema for the model. For `application/json` models, this should be JSON schema draft 4 model. The maximum size of the model is 400 KB.  
Type: String  
Required: No

## Response Syntax
<a name="API_CreateModel_ResponseSyntax"></a>

```
HTTP/1.1 201
Content-type: application/json

{
   "contentType": "string",
   "description": "string",
   "id": "string",
   "name": "string",
   "schema": "string"
}
```

## Response Elements
<a name="API_CreateModel_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 201 response.

The following data is returned in JSON format by the service.

 ** [contentType](#API_CreateModel_ResponseSyntax) **   <a name="apigw-CreateModel-response-contentType"></a>
The content-type for the model.  
Type: String

 ** [description](#API_CreateModel_ResponseSyntax) **   <a name="apigw-CreateModel-response-description"></a>
The description of the model.  
Type: String

 ** [id](#API_CreateModel_ResponseSyntax) **   <a name="apigw-CreateModel-response-id"></a>
The identifier for the model resource.  
Type: String

 ** [name](#API_CreateModel_ResponseSyntax) **   <a name="apigw-CreateModel-response-name"></a>
The name of the model. Must be an alphanumeric string.  
Type: String

 ** [schema](#API_CreateModel_ResponseSyntax) **   <a name="apigw-CreateModel-response-schema"></a>
The schema for the model. For `application/json` models, this should be JSON schema draft 4 model. Do not include "\$1\$1/" characters in the description of any properties because such "\$1\$1/" characters may be interpreted as the closing marker for comments in some languages, such as Java or JavaScript, causing the installation of your API's SDK generated by API Gateway to fail.  
Type: String

## Errors
<a name="API_CreateModel_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** BadRequestException **   
The submitted request is not valid, for example, the input is incomplete or incorrect. See the accompanying error message for details.  
HTTP Status Code: 400

 ** ConflictException **   
The request configuration has conflicts. For details, see the accompanying error message.  
HTTP Status Code: 409

 ** LimitExceededException **   
The request exceeded the rate limit. Retry after the specified time period.  
HTTP Status Code: 429

 ** NotFoundException **   
The requested resource is not found. Make sure that the request URI is correct.  
HTTP Status Code: 404

 ** TooManyRequestsException **   
The request has reached its throttling limit. Retry after the specified time period.  
HTTP Status Code: 429

 ** UnauthorizedException **   
The request is denied because the caller has insufficient permissions.  
HTTP Status Code: 401

## Examples
<a name="API_CreateModel_Examples"></a>

### Create a model
<a name="API_CreateModel_Example_1"></a>

This example illustrates one usage of CreateModel.

#### Sample Request
<a name="API_CreateModel_Example_1_Request"></a>

```
POST /restapis/uojnr9hd57/models HTTP/1.1
Content-Type: application/json
Host: apigateway.us-east-1.amazonaws.com
X-Amz-Date: 20160614T173659Z
Authorization: AWS4-HMAC-SHA256 Credential={access_key_ID}/20160614/us-east-1/apigateway/aws4_request, SignedHeaders=content-length;content-type;host;x-amz-date, Signature={sig4_hash}

{
  "name" : "CalcOutput",
  "description" : "Calc output model",
  "schema" : "{\n\t\"title\": \"Calc output\",\n\t\"type\": \"object\",\n\t\"properties\": {\n\t\t\"a\": {\n\t\t\t\"type\": \"number\"\n\t\t},\n\t\t\"b\": {\n\t\t\t\"type\": \"number\"\n\t\t},\n\t\t\"op\": {\n\t\t\t\"description\": \"operation of +, -, * or /\",\n\t\t\t\"type\": \"string\"\n\t\t},\n\t\t\"c\": {\n\t\t    \"type\": \"number\"\n\t\t}\n\t},\n\t\"required\": [\"a\", \"b\", \"op\"]\n}\n",
  "contentType" : "application/json"
}
```

#### Sample Response
<a name="API_CreateModel_Example_1_Response"></a>

```
{
  "_links": {
    "curies": {
      "href": "https://docs.aws.amazon.com/apigateway/latest/developerguide/restapi-model-{rel}.html",
      "name": "model",
      "templated": true
    },
    "self": {
      "href": "/restapis/uojnr9hd57/models/CalcOutput?flatten=false"
    },
    "model:create": {
      "href": "/restapis/uojnr9hd57/models"
    },
    "model:delete": {
      "href": "/restapis/uojnr9hd57/models/CalcOutput"
    },
    "model:generate-template": {
      "href": "/restapis/uojnr9hd57/models/CalcOutput/default_template"
    },
    "model:update": {
      "href": "/restapis/uojnr9hd57/models/CalcOutput"
    }
  },
  "contentType": "application/json",
  "description": "Calc output model",
  "id": "mzy1a0",
  "name": "CalcOutput",
  "schema": "{\n\t\"title\": \"Calc output\",\n\t\"type\": \"object\",\n\t\"properties\": {\n\t\t\"a\": {\n\t\t\t\"type\": \"number\"\n\t\t},\n\t\t\"b\": {\n\t\t\t\"type\": \"number\"\n\t\t},\n\t\t\"op\": {\n\t\t\t\"description\": \"operation of +, -, * or /\",\n\t\t\t\"type\": \"string\"\n\t\t},\n\t\t\"c\": {\n\t\t    \"type\": \"number\"\n\t\t}\n\t},\n\t\"required\": [\"a\", \"b\", \"op\"]\n}\n"
}
```

## See Also
<a name="API_CreateModel_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/apigateway-2015-07-09/CreateModel) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/apigateway-2015-07-09/CreateModel) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/apigateway-2015-07-09/CreateModel) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/apigateway-2015-07-09/CreateModel) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/apigateway-2015-07-09/CreateModel) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/apigateway-2015-07-09/CreateModel) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/apigateway-2015-07-09/CreateModel) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/apigateway-2015-07-09/CreateModel) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/apigateway-2015-07-09/CreateModel) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/apigateway-2015-07-09/CreateModel) 